#include SFSECURITY.H

loSecurity = newobject('SFSecurity', 'SFSecurity.vcx')
if not loSecurity.Setup()
	messagebox(loSecurity.cErrorMessage)
	return
endif not loSecurity.Setup()

with loSecurity

* Set the key seed values.

	.cKeySeed1 = 'FoxTalk provides'
	.cKeySeed2 = 'great value'
	.cKeySeed3 = 'for Visual'
	.cKeySeed4 = 'FoxPro developers.'
	.cKeySeed5 = 'Fox Rocks!'

* Create the ADMIN user.

	loUser           = .oUsers.Add('ADMIN')
	loUser.Password  = .Encrypt('Testing123')
	loUser.FirstName = 'Administrative'
	loUser.LastName  = 'User'

* Create the DHENNIG user.

	loUser           = .oUsers.Add('DHENNIG')
	loUser.Password  = .Encrypt('DumbPassword')
	loUser.FirstName = 'Doug'
	loUser.LastName  = 'Hennig'

* Add the ADMIN user to the various roles.

	loUser = .oUsers.Item('ADMIN')
	.AddUserToRole(loUser.ID, .oRoles.iAdministratorsID)
	.AddUserToRole(loUser.ID, .oRoles.iEveryoneID)

* Add the DHENNIG user to the appropriate roles.

	loUser = .oUsers.Item('DHENNIG')
	.AddUserToRole(loUser.ID, .oRoles.iEveryoneID)

* See which roles are available for DHENNIG, then add and remove the
* Administrators role.

	loUser = .oUsers.Item('DHENNIG')
	messagebox('DHENNIG is ' + iif(.IsUserInRole(loUser.ID, ;
		.oRoles.iAdministratorsID), '', 'not ') + ;
		'in the Administrators role.')
	.AddUserToRole(loUser.ID, .oRoles.iAdministratorsID)
	messagebox('DHENNIG is ' + iif(.IsUserInRole(loUser.ID, ;
		.oRoles.iAdministratorsID), '', 'not ') + ;
		'in the Administrators role.')
	loRoles = .GetRolesForUser(loUser.ID)
	lcRoles = ''
	for each loRole in loRoles
		lcRoles = lcRoles + iif(empty(lcRoles), '', ', ') + loRole.Name
	next loRole
	messagebox('DHENNIG is in the following roles:' + chr(13) + chr(13) + ;
		lcRoles)
	.RemoveUserFromRole(loUser.ID, .oRoles.iAdministratorsID)
	messagebox('DHENNIG is ' + iif(.IsUserInRole(loUser.ID, ;
		.oRoles.iAdministratorsID), '', 'not ') + ;
		'in the Administrators role.')

* Add some rights for the roles.

	.UpdateRightsForElement(1, .oRoles.iEveryoneID,       cnACCESS_WRITE)
		&& customers form
	.UpdateRightsForElement(2, .oRoles.iEveryoneID,       cnACCESS_READ)
		&& orders form
	.UpdateRightsForElement(2, .oRoles.iAdministratorsID, cnACCESS_WRITE)
		&& orders form
	.UpdateRightsForElement(3, .oRoles.iAdministratorsID, cnACCESS_WRITE)
		&& administrator's form

* Log in and display which rights the logged-in user has.

	messagebox('Log in as DHENNIG with a password of DumbPassword.')
	if .Login()
		liRights1 = .GetUserRightsForElement(1)
		liRights2 = .GetUserRightsForElement(2)
		liRights3 = .GetUserRightsForElement(3)
		messagebox(.oCurrentUser.UserName + ' has the following rights:' + ;
			chr(13) + chr(13) + ;
			'Customers form: ' + GetRightsDescription(liRights1) + chr(13) + ;
			'Orders form: ' + GetRightsDescription(liRights2) + chr(13) + ;
			'Admin form: ' + GetRightsDescription(liRights3))
	endif .Login()
endwith

function GetRightsDescription(tiRights)
local lcRights
lcRights = icase(tiRights = cnACCESS_NONE, 'None', ;
	tiRights = cnACCESS_READ, 'Read-only', ;
	tiRights = cnACCESS_WRITE, 'Read-write')
return lcRights
